/*
 *
 * INIFILE - RATFile extension for initialisation files
 *
 * by Roger Burton West <roger@firedrake.demon.co.uk>
 *
 * Whatever it does, it's your fault
 *
 */

#ifndef _INIFILE_H
#define _INIFILE_H

#include "ratfile.h"

#define MAX_INI_SEC 255

class INIFile : public RATFile {
private:
  int seccount;
  XString section[MAX_INI_SEC];
  RATPOS *secstart[MAX_INI_SEC];
  int secnum;
public:
  INIFile(const char *fullfilename,const char *cmode="r");
  INIFile();
  int Open(const char *fullfilename,const char *cmode="r");
  bool Section(const char *secname);
  XString ReadKey(const char *key);
  int WriteKey(const char *key,const char *value);
  XString ReadSerial();
  int AddSerial(const char *serial);
  int DelSerial(const char *serial);
  int Close();
  ~INIFile();
};

#endif
