/*
 * Read/write HConfig data
 * part of the Host-Toolkit library
 */

#include <stdio.h>
#include "tkhost.h"
#include "tkh.h"
#include "tkiocomm.h"

HCONFIG *read_hconfig()
{
  FILE *handle;
  HCONFIG *str;
  int k;

  handle=mkopen("hconfig.hst",false,'r');
  if (!handle) return NULL;

  str=new HCONFIG;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->wRecycleRate=readUB2(handle);
  str->wRandomMeteorRate=readUB2(handle);
  str->wAllowMinefields=readUB2(handle);
  str->wAllowAlchemy=readUB2(handle);
  str->wDeleteOldMessages=readUB2(handle);
  str->wDisablePasswords=readUB2(handle);
  for(k=0;k<12;k++) {
    str->wGroundKillFactor[k]=readUB2(handle);
  }
  for(k=0;k<12;k++) {
    str->wGroundDefenseFactor[k]=readUB2(handle);
  }
  for(k=0;k<12;k++) {
    str->wFreeFighters[k]=readUB2(handle);
  }
  for(k=0;k<12;k++) {
    str->wRaceMiningRate[k]=readUB2(handle);
  }
  for(k=0;k<13;k++) {
    str->wRaceTaxRate[k]=readUB2(handle);
  }
  str->wRebelsBuildFighters=readUB2(handle);
  str->wColoniesBuildFighters=readUB2(handle);
  str->wRobotsBuildFighters=readUB2(handle);
  str->wCloakFailureRate=readUB2(handle);
  str->wRobCloakedShips=readUB2(handle);
  str->wScanRange=readUB2(handle);
  str->wDarkSenseRange=readUB2(handle);
  str->wAllowHiss=readUB2(handle);
  str->wAllowRebelGroundAttack=readUB2(handle);
  str->wAllowSuperRefit=readUB2(handle);
  str->wAllowWebMines=readUB2(handle);
  str->wCloakFuelBurn=readUB2(handle);
  str->wSensorRange=readUB2(handle);
  str->wAllowNewNatives=readUB2(handle);
  str->wAllowNUKCode=readUB2(handle);
  str->wBorgAssimilationRate=readUB2(handle);
  str->wWebMineDecayRate=readUB2(handle);
  str->wMineDecayRate=readUB2(handle);
  str->wMaximumMinefieldRadius=readUB2(handle);
  str->wTransuraniumDecayRate=readUB2(handle);
  str->wStructureDecayPerTurn=readUB2(handle);
  str->wAllowEatingSupplies=readUB2(handle);
  str->wAllowNoFuelMovement=readUB2(handle);
  str->wMineHitOdds=readUB2(handle);
  str->wWebMineHitOdds=readUB2(handle);
  str->wMineScanRange=readUB2(handle);
  str->wAllowMinesDestroyMines=readUB2(handle);
  str->wAllowEngineShieldBonus=readUB2(handle);
  str->wEngineShieldBonusRate=readUB2(handle);
  str->wColonialFighterSweepRate=readUB2(handle);
  str->wAllowColoniesSweepWebs=readUB2(handle);
  str->wMineSweepRate=readUB2(handle);
  str->wWebMineSweepRate=readUB2(handle);
  str->wHissEffectRate=readUB2(handle);
  str->wRobFailureOdds=readUB2(handle);
  str->wPlanetsAttackRebels=readUB2(handle);
  str->wPlanetsAttackKlingons=readUB2(handle);
  str->wMineSweepRange=readUB2(handle);
  str->wWebMineSweepRange=readUB2(handle);
  str->wAllowScienceMission=readUB2(handle);
  str->wMineHitOddsWhenCloakedX10=readUB2(handle);
  str->wDamageLevelForCloakFail=readUB2(handle);
  str->wAllowFedCombatBonus=readUB2(handle);
  str->wMeteorShowerOdds=readUB2(handle);
  str->wMeteorShowerOreMinFuel=readUB4(handle);
  str->wMeteorShowerOreMinDur=readUB4(handle);
  str->wMeteorShowerOreMinTri=readUB4(handle);
  str->wMeteorShowerOreMinMol=readUB4(handle);
  str->wMeteorShowerOreMaxFuel=readUB4(handle);
  str->wMeteorShowerOreMaxDur=readUB4(handle);
  str->wMeteorShowerOreMaxTri=readUB4(handle);
  str->wMeteorShowerOreMaxMoly=readUB4(handle);
  str->wLargeMeteorsImpacting=readUB2(handle);
  str->wLargeMeteorOreMinFuel=readUB4(handle);
  str->wLargeMeteorOreMinDur=readUB4(handle);
  str->wLargeMeteorOreMinTri=readUB4(handle);
  str->wLargeMeteorOreMinMoly=readUB4(handle);
  str->wLargeMeteorOreMaxFuel=readUB4(handle);
  str->wLargeMeteorOreMaxDur=readUB4(handle);
  str->wLargeMeteorOreMaxTri=readUB4(handle);
  str->wLargeMeteorOreMaxMoly=readUB4(handle);
  str->wAllowMeteorMessages=readUB2(handle);
  str->wAllowOneEngineTowing=readUB2(handle);
  str->wAllowHyperWarps=readUB2(handle);
  str->wClimateDeathRate=readUB2(handle);
  str->wAllowGravityWells=readUB2(handle);
  str->wCrystalsPreferDeserts=readUB2(handle);
  str->wAllowMinesDestroyWebs=readUB2(handle);
  str->wClimateLimitsPopulation=readUB2(handle);
  str->wMaxPlanetaryIncome=readUB4(handle);
  str->wIonStormActivity=readUB2(handle);
  str->wAllowChunneling=readUB2(handle);
  str->wAllowDeluxeSuperSpy=readUB2(handle);
  str->wIonStormsHideMines=readUB2(handle);
  str->wAllowGloryDevice=readUB2(handle);
  str->wAllowAntiCloakShips=readUB2(handle);
  str->wAllowGamblingShips=readUB2(handle);
  str->wAllowCloakedShipsAttack=readUB2(handle);
  str->wAllowCloning=readUB2(handle);
  str->wAllowBoardingParties=readUB2(handle);
  str->wAllowImperialAssault=readUB2(handle);
  str->wRamScoopFuelPerLY=readUB2(handle);
  str->wAllowAdvancedRefinery=readUB2(handle);
  str->wAllowBioscanners=readUB2(handle);
  str->wHullTechNotSlowedByMines=readUB2(handle);

  fclose(handle);
  return str;
}

bool write_hconfig(HCONFIG *str)
{
  FILE *handle;
  int k;
  bool v;

  handle=mkopen("hconfig.hst",false,'w');
  if (!handle) return false;

  v=writeUB2(handle,str->wRecycleRate);
  if (v) v=writeUB2(handle,str->wRandomMeteorRate);
  if (v) v=writeUB2(handle,str->wAllowMinefields);
  if (v) v=writeUB2(handle,str->wAllowAlchemy);
  if (v) v=writeUB2(handle,str->wDeleteOldMessages);
  if (v) v=writeUB2(handle,str->wDisablePasswords);
  for (k=1;k<13;k++) {
    if (v) v=writeUB2(handle,str->wGroundKillFactor[k]);
  }
  for (k=1;k<13;k++) {
    if (v) v=writeUB2(handle,str->wGroundDefenseFactor[k]);
  }
  for (k=1;k<13;k++) {
    if (v) v=writeUB2(handle,str->wFreeFighters[k]);
  }
  for (k=1;k<13;k++) {
    if (v) v=writeUB2(handle,str->wRaceMiningRate[k]);
  }
  for (k=1;k<12;k++) {
    if (v) v=writeUB2(handle,str->wRaceTaxRate[k]);
  }
  if (v) v=writeUB2(handle,str->wRebelsBuildFighters);
  if (v) v=writeUB2(handle,str->wColoniesBuildFighters);
  if (v) v=writeUB2(handle,str->wRobotsBuildFighters);
  if (v) v=writeUB2(handle,str->wCloakFailureRate);
  if (v) v=writeUB2(handle,str->wRobCloakedShips);
  if (v) v=writeUB2(handle,str->wScanRange);
  if (v) v=writeUB2(handle,str->wDarkSenseRange);
  if (v) v=writeUB2(handle,str->wAllowHiss);
  if (v) v=writeUB2(handle,str->wAllowRebelGroundAttack);
  if (v) v=writeUB2(handle,str->wAllowSuperRefit);
  if (v) v=writeUB2(handle,str->wAllowWebMines);
  if (v) v=writeUB2(handle,str->wCloakFuelBurn);
  if (v) v=writeUB2(handle,str->wSensorRange);
  if (v) v=writeUB2(handle,str->wAllowNewNatives);
  if (v) v=writeUB2(handle,str->wAllowNUKCode);
  if (v) v=writeUB2(handle,str->wBorgAssimilationRate);
  if (v) v=writeUB2(handle,str->wWebMineDecayRate);
  if (v) v=writeUB2(handle,str->wMineDecayRate);
  if (v) v=writeUB2(handle,str->wMaximumMinefieldRadius);
  if (v) v=writeUB2(handle,str->wTransuraniumDecayRate);
  if (v) v=writeUB2(handle,str->wStructureDecayPerTurn);
  if (v) v=writeUB2(handle,str->wAllowEatingSupplies);
  if (v) v=writeUB2(handle,str->wAllowNoFuelMovement);
  if (v) v=writeUB2(handle,str->wMineHitOdds);
  if (v) v=writeUB2(handle,str->wWebMineHitOdds);
  if (v) v=writeUB2(handle,str->wMineScanRange);
  if (v) v=writeUB2(handle,str->wAllowMinesDestroyMines);
  if (v) v=writeUB2(handle,str->wAllowEngineShieldBonus);
  if (v) v=writeUB2(handle,str->wEngineShieldBonusRate);
  if (v) v=writeUB2(handle,str->wColonialFighterSweepRate);
  if (v) v=writeUB2(handle,str->wAllowColoniesSweepWebs);
  if (v) v=writeUB2(handle,str->wMineSweepRate);
  if (v) v=writeUB2(handle,str->wWebMineSweepRate);
  if (v) v=writeUB2(handle,str->wHissEffectRate);
  if (v) v=writeUB2(handle,str->wRobFailureOdds);
  if (v) v=writeUB2(handle,str->wPlanetsAttackRebels);
  if (v) v=writeUB2(handle,str->wPlanetsAttackKlingons);
  if (v) v=writeUB2(handle,str->wMineSweepRange);
  if (v) v=writeUB2(handle,str->wWebMineSweepRange);
  if (v) v=writeUB2(handle,str->wAllowScienceMission);
  if (v) v=writeUB2(handle,str->wMineHitOddsWhenCloakedX10);
  if (v) v=writeUB2(handle,str->wDamageLevelForCloakFail);
  if (v) v=writeUB2(handle,str->wAllowFedCombatBonus);
  if (v) v=writeUB2(handle,str->wMeteorShowerOdds);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMinFuel);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMinDur);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMinTri);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMinMol);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMaxFuel);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMaxDur);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMaxTri);
  if (v) v=writeUB4(handle,str->wMeteorShowerOreMaxMoly);
  if (v) v=writeUB2(handle,str->wLargeMeteorsImpacting);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMinFuel);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMinDur);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMinTri);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMinMoly);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMaxFuel);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMaxDur);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMaxTri);
  if (v) v=writeUB4(handle,str->wLargeMeteorOreMaxMoly);
  if (v) v=writeUB2(handle,str->wAllowMeteorMessages);
  if (v) v=writeUB2(handle,str->wAllowOneEngineTowing);
  if (v) v=writeUB2(handle,str->wAllowHyperWarps);
  if (v) v=writeUB2(handle,str->wClimateDeathRate);
  if (v) v=writeUB2(handle,str->wAllowGravityWells);
  if (v) v=writeUB2(handle,str->wCrystalsPreferDeserts);
  if (v) v=writeUB2(handle,str->wAllowMinesDestroyWebs);
  if (v) v=writeUB2(handle,str->wClimateLimitsPopulation);
  if (v) v=writeUB4(handle,str->wMaxPlanetaryIncome);
  if (v) v=writeUB2(handle,str->wIonStormActivity);
  if (v) v=writeUB2(handle,str->wAllowChunneling);
  if (v) v=writeUB2(handle,str->wAllowDeluxeSuperSpy);
  if (v) v=writeUB2(handle,str->wIonStormsHideMines);
  if (v) v=writeUB2(handle,str->wAllowGloryDevice);
  if (v) v=writeUB2(handle,str->wAllowAntiCloakShips);
  if (v) v=writeUB2(handle,str->wAllowGamblingShips);
  if (v) v=writeUB2(handle,str->wAllowCloakedShipsAttack);
  if (v) v=writeUB2(handle,str->wAllowCloning);
  if (v) v=writeUB2(handle,str->wAllowBoardingParties);
  if (v) v=writeUB2(handle,str->wAllowImperialAssault);
  if (v) v=writeUB2(handle,str->wRamScoopFuelPerLY);
  if (v) v=writeUB2(handle,str->wAllowAdvancedRefinery);
  if (v) v=writeUB2(handle,str->wAllowBioscanners);
  if (v) v=writeUB2(handle,str->wHullTechNotSlowedByMines);

  fclose(handle);
  return v;
}
