/*
 * Read gen??.dat and race names
 * part of the Player-Toolkit package
 */

#include <stdio.h>
#include "tkplayer.h"
#include "tkp.h"
#include "tkiocomm.h"

RACENM * read_racenm(int rnum)
{
  FILE *handle;
  RACENM *str;

  handle=mkopen("race.nm",true,'r');
  if (!handle) return NULL;

  if (rnum>NUM_RACES || rnum<1) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,62*(rnum-1),SEEK_SET);

  str=new RACENM;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  fseek(handle,30*(rnum-1),SEEK_SET);
  str->sFull=readXString(handle,30);

  fseek(handle,330+20*(rnum-1),SEEK_SET);
  str->sPlural=readXString(handle,20);

  fseek(handle,550+12*(rnum-1),SEEK_SET);
  str->sAdjective=readXString(handle,12);

  fclose(handle);
  return str;
}

RACENM *read_all_racenm()
{
  FILE *handle;
  RACENM *str;
  int vnum;

  handle=mkopen("race.nm",true,'r');
  if (!handle) return NULL;

  str=new RACENM [12];
  if (!str) {
    fclose(handle);
    return NULL;
  }

  for(vnum=1;vnum<=11;vnum++) {
    str[vnum].sFull=readXString(handle,30);
  }
  for(vnum=1;vnum<=11;vnum++) {
    str[vnum].sPlural=readXString(handle,20);
  }
  for(vnum=1;vnum<=11;vnum++) {
    str[vnum].sAdjective=readXString(handle,12);
  }

  fclose(handle);
  return str;
}

GENDATA * read_gendata()
{
  GENDATA *str;
  FILE *handle;
  int k;
  XString pw1;
  unsigned char c;

  handle=mkopen("gen&p.dat",false,'r');
  if (!handle) return NULL;

  str=new GENDATA;
  if (!str) {
    fclose(handle);
    return NULL;
  }

  str->sDateHost=readXString(handle,10);
  str->sTimeHost=readXString(handle,8);
  for(k=1;k<=NUM_RACES;k++) {
    str->Scores[k].wPlanets=readUB2(handle);
    str->Scores[k].wCapitalShips=readUB2(handle);
    str->Scores[k].wFreighters=readUB2(handle);
    str->Scores[k].wBases=readUB2(handle);
  }
  str->wPlayer=readUB2(handle);
  pw1=readXString(handle,10);
  str->sSignature1=readXString(handle,10);
  str->sSignature2="";
  for(k=0;k<10;k++) {
    str->sSignature2 |= (str->sSignature1.GetAt(k)+k+1);
    c=pw1.GetAt(k) - str->sSignature1.GetAt(9-k) + 32;
    if (c>127) c=0;
    str->sPassword |= c;
  }
  if (str->sPassword=="NOPASSWORD") str->sPassword="";
  fseek(handle,129,SEEK_SET);
  str->lCS_Ship=readUB4(handle);
  str->lCS_Planet=readUB4(handle);
  str->lCS_Base=readUB4(handle);
  str->wIsNewPwd=readUB2(handle);
  str->sNewPass=readXString(handle,10);
  for(k=0;k<10;k++) {
    str->sNewPass.SetAt(k,str->sNewPass.GetAt(k)-50);
  }
  str->wTurnNr=readUB2(handle);
  str->wHostID=readUB2(handle);
  fclose(handle);
  return str;
}

